<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Document</title>

    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.4.1/js/bootstrap.min.js"></script>
    <link
      rel="stylesheet"
      href="https://stackpath.bootstrapcdn.com/bootstrap/4.1.3/css/bootstrap.min.css"
      integrity="sha384-MCw98/SFnGE8fJT3GXwEOngsV7Zt27NXFoaoApmYm81iuXoPkFOJwJ8ERdknLPMO"
      crossorigin="anonymous"
    />

    <link rel="preconnect" href="https://fonts.googleapis.com" />
    <link rel="preconnect" href="https://fonts.gstatic.com" crossorigin />
    <link
      href="https://fonts.googleapis.com/css2?family=DM+Serif+Display&family=Inter&family=Jost&family=Kaisei+Decol&family=Montserrat&family=Open+Sans:wght@300&family=Space+Grotesk&display=swap"
      rel="stylesheet"
    />

    <style>
      .right-content {
        padding: 5rem 3rem 5rem 3rem;
        background: linear-gradient(142deg, #517879 1.09%, #1e3e57 100%);
      }

      .creativity {
        color: #fff;
        font-family: Space Grotesk;
        font-size: 64px;
        font-style: normal;
        font-weight: 700;
        line-height: 96px; /* 150% */
      }

      .albert {
        color: #fff;
        font-family: Space Grotesk;
        font-size: 16px;
        font-style: normal;
        font-weight: 700;
        line-height: 24px; /* 150% */
      }

      .tittle {
        color: #000;
        font-family: Space Grotesk;
        font-size: 24px;
        font-style: normal;
        font-weight: 700;
        line-height: 36px; /* 150% */
        margin-bottom: 4rem;
      }

      .form-label {
        color: #3f3d56;
        font-family: Open Sans;
        font-size: 12px;
        font-style: normal;
        font-weight: 400;
        line-height: normal;
      }

      .sign-up-button {
        width: 100%;
        padding: 8px;
        margin-top: 45px;
        margin-bottom: 80px;
        border-radius: 4px;
        border: 1px solid #284a5e;
        background: #27485d;
        box-shadow: 0px 2px 2px 2px rgba(204, 204, 204, 0.1);

        color: #fff;
        font-family: Space Grotesk;
        font-size: 16px;
        font-style: normal;
        font-weight: 700;
        line-height: 24px; /* 150% */
      }

      .already {
        text-align: center;
        color: #c4c4c4;
        font-family: Space Grotesk;
        font-size: 16px;
        font-style: normal;
        font-weight: 700;
        line-height: 24px; /* 150% */
      }

      .already-span {
        color: #476d73;
        font-family: Space Grotesk;
        font-size: 16px;
        font-style: normal;
        font-weight: 700;
        line-height: 24px; /* 150% */
        text-decoration-line: underline;
      }

      ::-webkit-input-placeholder {
        color: #ccc;
        font-family: Space Grotesk;
        font-size: 12px;
        font-style: normal;
        font-weight: 400;
        line-height: 16px; /* 133.333% */
      }

      .left-content {
        padding: 5rem;
        background-image: url("images/Stroke5.png");
        background-size: 35rem 30rem;
        background-repeat: no-repeat;
      }

      .pass-note {
        color: #ccc;
        font-family: Space Grotesk;
        font-size: 12px;
        font-style: normal;
        font-weight: 400;
        line-height: 16px; /* 133.333% */
      }
    </style>
  </head>
  <body>
    <div class="container-fluid">
      <div class="row">
        <div class="col-md-7 left-content">
          <div class="tittle">Let’s get you started</div>

          <form action="" id="loginForm">
            <div class="form-group">
              <label for="" class="form-label">Full name</label>
              <input
                id="input-name"
                type="text"
                class="form-control"
                placeholder="Ade Tiger"
              />
            </div>
            <div class="form-group">
              <label for="" class="form-label">Email address</label>
              <input
                id="input-email"
                type="text"
                class="form-control"
                placeholder="yourname@email.com"
              />
            </div>
            <div class="form-group">
              <label for="" class="form-label">Create password</label>
              <input id="input-password" type="password" class="form-control" />
            </div>
            <p class="pass-note">
              Password must contain a minimum of 8 characters
            </p>
            <p class="pass-note">
              Password must contain at least one symbol e.g. @, !
            </p>
            <button class="sign-up-button">Sign up</button>
          </form>

          <p class="already">
            Already a user? <span class="already-span">Login</span>
          </p>
        </div>
        <div class="col-md-5 right-content">
          <div class="creativity">“Creativity is intelligence having fun”</div>
          <div class="albert">- Albert Einstein</div>
        </div>
      </div>
    </div>
  </body>

  <script>
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_STATUS_CREATED = 201;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gBASE_URL = "https://62458c222cfed18817229118.mockapi.io/users";
    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    var loginForm = document.getElementById("loginForm");
    loginForm.addEventListener("submit", (e) => {
      // Sử dụng preventDefault để loại bỏ hành động submit mặc định của form
      e.preventDefault();
      // Bước 0: Khởi tạo đối tượng thu thập
      var vObject = {
        name: "",
        email: "",
        password: "",
      };
      // Bước 1: thu thập dữ liệu
      getDataFromInput(vObject);
      // Bước 2: Kiểm tra dữ liệu thu thập
      var vCheck = validateData(vObject);
      // Bước 3: gọi API xử lý
      if (vCheck) {
        // create a request
        var vXmlHttpSignUp = new XMLHttpRequest();
        processAPI(vXmlHttpSignUp, vObject);
        vXmlHttpSignUp.onreadystatechange = function () {
          if (
            this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK &&
            this.status == gREQUEST_STATUS_CREATED
          ) {
            var vSignUpRespond = vXmlHttpSignUp.responseText;
            //B4: hiển thị dữ liệu
            hienThiDuLieu(vSignUpRespond);
          }
        };
      }
    });
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // Hàm thu thập dữ liệu
    function getDataFromInput(paramObject) {
      "use strict";
      var vNameInput = document.getElementById("input-name");
      var vEmailInput = document.getElementById("input-email");
      var vPassInput = document.getElementById("input-password");

      paramObject.name = vNameInput.value;
      paramObject.email = vEmailInput.value;
      paramObject.password = vPassInput.value;
    }

    // Hàm kiểm tra dữ liệu thu thập
    // Input là đối tượng dữ liệu cần kiểm tra
    // Output là kết quả true / false
    function validateData(paramObject) {
      "use strict";
      var vName = paramObject.name.trim(); // Chuẩn hóa dữ liệu
      var vEmail = paramObject.email.trim();
      var vPass = paramObject.password.trim();

      if (vName == "") {
        alert("Name is empty!");
        return false;
      }

      if (vEmail == "") {
        alert("Email is empty!");
        return false;
      }
      if (validateEmail(vEmail) == false) {
        alert("Email is invalid!");
        return false;
      }

      if (vPass == "") {
        alert("Password is empty!");
        return false;
      }

      return true;
    }

    // Hàm kiểm tra email
    // Input là email cần kiểm tra
    // Output là true / false
    function validateEmail(mail) {
      if (/^\w+([\.-]?\w+)*@\w+([\.-]?\w+)*(\.\w{2,3})+$/.test(mail)) {
        return true;
      }
      return false;
    }

    // Hàm xử lý ajax API login
    // Input là đối tượng Request và đối tượng dữ liệu
    function processAPI(paramRequest, paramObject) {
      "use strict";
      var vData = JSON.stringify({
        fullname: paramObject.name,
        username: paramObject.name,
        password: paramObject.password,
      });

      paramRequest.open("POST", gBASE_URL, true);
      paramRequest.send(vData);
    }

    //hàm hiển thị dữ liệu
    function hienThiDuLieu(paramSignUpRespond) {
      console.log(paramSignUpRespond);
    }
  </script>
</html>
